<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:13 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ArtifactResolutionQuery (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ArtifactResolutionQuery (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" target="_top">Frames</a></li>
<li><a href="ArtifactResolutionQuery.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.artifacts.query</div>
<h2 title="Interface ArtifactResolutionQuery" class="title">Interface ArtifactResolutionQuery</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">ArtifactResolutionQuery</span></pre>
<div class="block">A builder to construct a query that can resolve selected software artifacts of the specified components.

 <pre class='autoTested'>
 apply plugin: 'java'

 task resolveCompileSources {
     doLast {
         def componentIds = configurations.compile.incoming.resolutionResult.allDependencies.collect { it.selected.id }

         def result = dependencies.createArtifactResolutionQuery()
                                  .forComponents(componentIds)
                                  .withArtifacts(JvmLibrary, SourcesArtifact, JavadocArtifact)
                                  .execute()

         for (component in result.resolvedComponents) {
             component.getArtifacts(SourcesArtifact).each { println "Source artifact for ${component.id}: ${it.file}" }
         }
     }
 }
 </pre></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>2.0</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/result/ArtifactResolutionResult.html" title="interface in org.gradle.api.artifacts.result">ArtifactResolutionResult</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html#execute()">execute</a></strong>()</code>
<div class="block">Actually execute the query, returning a query result.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html#forComponents(org.gradle.api.artifacts.component.ComponentIdentifier...)">forComponents</a></strong>(<a href="../../../../../org/gradle/api/artifacts/component/ComponentIdentifier.html" title="interface in org.gradle.api.artifacts.component">ComponentIdentifier</a>...&nbsp;componentIds)</code>
<div class="block">Specifies the set of components to include in the result.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html#forComponents(java.lang.Iterable)">forComponents</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;? extends <a href="../../../../../org/gradle/api/artifacts/component/ComponentIdentifier.html" title="interface in org.gradle.api.artifacts.component">ComponentIdentifier</a>&gt;&nbsp;componentIds)</code>
<div class="block">Specifies the set of components to include in the result.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html#withArtifacts(java.lang.Class,%20java.lang.Class...)">withArtifacts</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/gradle/api/component/Component.html" title="interface in org.gradle.api.component">Component</a>&gt;&nbsp;componentType,
             <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/gradle/api/component/Artifact.html" title="interface in org.gradle.api.component">Artifact</a>&gt;...&nbsp;artifactTypes)</code>
<div class="block">Defines the type of component that is expected in the result, and the artifacts to retrieve for components of this type.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="forComponents(java.lang.Iterable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>forComponents</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a>&nbsp;forComponents(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;? extends <a href="../../../../../org/gradle/api/artifacts/component/ComponentIdentifier.html" title="interface in org.gradle.api.artifacts.component">ComponentIdentifier</a>&gt;&nbsp;componentIds)</pre>
<div class="block">Specifies the set of components to include in the result.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>componentIds</code> - The identifiers of the components to be queried.</dd></dl>
</li>
</ul>
<a name="forComponents(org.gradle.api.artifacts.component.ComponentIdentifier...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>forComponents</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a>&nbsp;forComponents(<a href="../../../../../org/gradle/api/artifacts/component/ComponentIdentifier.html" title="interface in org.gradle.api.artifacts.component">ComponentIdentifier</a>...&nbsp;componentIds)</pre>
<div class="block">Specifies the set of components to include in the result.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>componentIds</code> - The identifiers of the components to be queried.</dd></dl>
</li>
</ul>
<a name="withArtifacts(java.lang.Class, java.lang.Class...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>withArtifacts</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a>&nbsp;withArtifacts(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/gradle/api/component/Component.html" title="interface in org.gradle.api.component">Component</a>&gt;&nbsp;componentType,
                                    <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/gradle/api/component/Artifact.html" title="interface in org.gradle.api.component">Artifact</a>&gt;...&nbsp;artifactTypes)</pre>
<div class="block">Defines the type of component that is expected in the result, and the artifacts to retrieve for components of this type.

 Presently, only a single component type and set of artifacts is permitted.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>componentType</code> - The expected type of the component.</dd><dd><code>artifactTypes</code> - The artifacts to retrieve for the queried components.</dd></dl>
</li>
</ul>
<a name="execute()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>execute</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/result/ArtifactResolutionResult.html" title="interface in org.gradle.api.artifacts.result">ArtifactResolutionResult</a>&nbsp;execute()</pre>
<div class="block">Actually execute the query, returning a query result.
 Note that <a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html#withArtifacts(java.lang.Class,%20java.lang.Class...)"><code>withArtifacts(Class, Class[])</code></a> must be called before executing the query.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" target="_top">Frames</a></li>
<li><a href="ArtifactResolutionQuery.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
